/*
 * The UDS Collection
 * Copyright (C) 2000, 2001  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */


// includes

#include <alloc.h>
#include <new>


extern "C" void*
malloc( size_t );


namespace uds
{

using namespace std;

// the original operator new ()
// the code of this function is based on the standard operator new (),
// taken from the GNU Compiler Collection version 2.95.2
// (http://gcc.gnu.org)

inline void*
_original_new( size_t sz ) throw ( std::bad_alloc )
{
	// malloc( 0 ) is unpredictable; avoid it.
	if ( sz == 0 )
		sz = 1;
	
	void* p = static_cast< void* >( malloc( sz ) );
	while ( !p )
	{
		// get new handler
		typedef void ( * new_handler )();
		
		// workaraound for non-gnu standard C++ libraries
		new_handler handler = set_new_handler( 0 );
		set_new_handler( handler );
		
		if ( !handler )
			throw bad_alloc();
		handler();
		
		p = static_cast< void* >( malloc( sz ) );
	}
	
	return p;
}

void*
original_new( size_t sz ) throw ( std::bad_alloc ) __attribute__(( weak ));

}
